(Leetcode)Longest Increasing Subsequence——dp,bisearch

300. Longest Increasing Subsequence

题目
Given an unsorted array of integers, find the length of longest increasing subsequence.

For example,
Given [10, 9, 2, 5, 3, 7, 101, 18],
The longest increasing subsequence is [2, 3, 7, 101], therefore the length is 4. Note that there may be more than one LIS combination, it is only necessary for you to return the length.

Your algorithm should run in O(n2) complexity.

Follow up: Could you improve it to O(n log n) time complexity?

Solution 1: DP(9ms)——O( n2

每个dp[i]存储到当前元素的最大子数组长度。

Code(C)

int lengthOfLIS(int* nums, int numsSize) {
    if(numsSize<=0) return 0; 
    int *dp = (int *) malloc(sizeof(int)*numsSize);
    dp[0] = 0;
    int i=0; 
    int maxl = 1;
    for(i=0; i<numsSize; i++){
        int j=0;
        int cur = nums[i];
        dp[i] = 1;
        for(j=i-1; j>=0; j--){
            if(nums[j]<cur){
                if((j+2)<dp[i]) break;
                dp[i] = ( dp[i] < (dp[j]+1) ) ? dp[j]+1 : dp[i];
            }
        }
        maxl = (maxl>dp[i]) ? maxl : dp[i];
    }
    free(dp);
    return maxl;
}

Solution 2: DP(3ms)——O( nlog(n)

每个dp[i]前面构成长度为(i+1)的子序列,这个序列的最小的末尾数字。

/**
 * if find target, return the index of target
 * else, return (-(insertion point) - 1).
 * The insertion point is defined as the point at which the key would be inserted into the array.
 * same as Arrays.binearysearch() in java
 */
int bisearch(int *nums, int low, int high, int target){
    if(low <= high){
        int mid = (low+high)/2;
        if(nums[mid]==target) return mid;
        else if(nums[mid]>target) return bisearch(nums, low, mid-1, target);
        else return bisearch(nums, mid+1, high, target);
    }
    else{
        return (-low-1);
    }
}

int lengthOfLIS(int* nums, int numsSize) {
    if (numsSize <= 0) return 0;
    int *dp = (int *)malloc(sizeof(int)*numsSize);
    dp[0] = nums[0];
    int i = 0;
    int maxl = 0;
    for (i = 1; i<numsSize; i++){
        int cur = nums[i];
        int idx = bisearch(dp, 0, maxl, cur);
        if (idx<0) idx = -(idx + 1); // get insert idx of cur
        dp[idx] = cur;
        if (idx == (maxl+1)) maxl++;
    }
    free(dp);
    return maxl+1;
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值